zoukankan      html  css  js  c++  java
  • Codeforces Round #298 (Div. 2) D. Handshakes 构造

    D. Handshakes

    Time Limit: 1 Sec  Memory Limit: 256 MB

    题目连接

    http://codeforces.com/contest/534/problem/D

    Description

    On February, 30th n students came in the Center for Training Olympiad Programmers (CTOP) of the Berland State University. They came one by one, one after another. Each of them went in, and before sitting down at his desk, greeted with those who were present in the room by shaking hands. Each of the students who came in stayed in CTOP until the end of the day and never left.

    At any time any three students could join together and start participating in a team contest, which lasted until the end of the day. The team did not distract from the contest for a minute, so when another student came in and greeted those who were present, he did not shake hands with the members of the contest writing team. Each team consisted of exactly three students, and each student could not become a member of more than one team. Different teams could start writing contest at different times.

    Given how many present people shook the hands of each student, get a possible order in which the students could have come to CTOP. If such an order does not exist, then print that this is impossible.

    Please note that some students could work independently until the end of the day, without participating in a team contest.

    Input

    The first line contains integer n (1 ≤ n ≤ 2·105) — the number of students who came to CTOP. The next line contains n integers a1, a2, ..., an (0 ≤ ai < n), where ai is the number of students with who the i-th student shook hands.

    Output

    If the sought order of students exists, print in the first line "Possible" and in the second line print the permutation of the students' numbers defining the order in which the students entered the center. Number i that stands to the left of number j in this permutation means that the i-th student came earlier than the j-th student. If there are multiple answers, print any of them.

    If the sought order of students doesn't exist, in a single line print "Impossible".


    Sample Input

    input1
    5
    2 1 3 0 1
    input2
    9
    0 2 3 4 1 1 0 2 2

    Sample Output

    Possible
    4 5 1 3 2
     
    Possible
    7 5 2 1 6 8 3 4 9

    HINT

    In the first sample from the statement the order of events could be as follows:

    • student 4 comes in (a4 = 0), he has no one to greet;
    • student 5 comes in (a5 = 1), he shakes hands with student 4;
    • student 1 comes in (a1 = 2), he shakes hands with two students (students 4, 5);
    • student 3 comes in (a3 = 3), he shakes hands with three students (students 4, 5, 1);
    • students 4, 5, 3 form a team and start writing a contest;
    • student 2 comes in (a2 = 1), he shakes hands with one student (number 1).

    In the second sample from the statement the order of events could be as follows:

    • student 7 comes in (a7 = 0), he has nobody to greet;
    • student 5 comes in (a5 = 1), he shakes hands with student 7;
    • student 2 comes in (a2 = 2), he shakes hands with two students (students 7, 5);
    • students 7, 5, 2 form a team and start writing a contest;
    • student 1 comes in(a1 = 0), he has no one to greet (everyone is busy with the contest);
    • student 6 comes in (a6 = 1), he shakes hands with student 1;
    • student 8 comes in (a8 = 2), he shakes hands with two students (students 1, 6);
    • student 3 comes in (a3 = 3), he shakes hands with three students (students 1, 6, 8);
    • student 4 comes in (a4 = 4), he shakes hands with four students (students 1, 6, 8, 3);
    • students 8, 3, 4 form a team and start writing a contest;
    • student 9 comes in (a9 = 2), he shakes hands with two students (students 1, 6).

    In the third sample from the statement the order of events is restored unambiguously:

    • student 1 comes in (a1 = 0), he has no one to greet;
    • student 3 comes in (or student 4) (a3 = a4 = 1), he shakes hands with student 1;
    • student 2 comes in (a2 = 2), he shakes hands with two students (students 1, 3 (or 4));
    • the remaining student 4 (or student 3), must shake one student's hand (a3 = a4 = 1) but it is impossible as there are only two scenarios: either a team formed and he doesn't greet anyone, or he greets all the three present people who work individually.

    题意

    给你n个人,然后告诉你这n个人进去的时候分别里面坐着有d[i]个人
    如果里面坐着有三个人或者三个人以上的话,这三个人可以选择离开
    然后问你能不能找出一种可行解

    题解:

    直接暴力特判就好了,我们拿一个flag记录这个房间里面有多少个人
    每次查询是否存在flag,如果不存在我们就flag-3,之后再继续检查,直到flag被降为负数
    然后我们再判一判是否所有人都已经进去了就好了~

    代码:

    //qscqesze
    #include <cstdio>
    #include <cmath>
    #include <cstring>
    #include <ctime>
    #include <iostream>
    #include <algorithm>
    #include <set>
    #include <vector>
    #include <sstream>
    #include <queue>
    #include <typeinfo>
    #include <fstream>
    #include <map>
    typedef long long ll;
    using namespace std;
    //freopen("D.in","r",stdin);
    //freopen("D.out","w",stdout);
    #define sspeed ios_base::sync_with_stdio(0);cin.tie(0)
    #define maxn 200001
    #define mod 10007
    #define eps 1e-9
    //const int inf=0x7fffffff;   //无限大
    const int inf=0x3f3f3f3f;
    /*
    inline ll read()
    {
        int x=0,f=1;char ch=getchar();
        while(ch<'0'||ch>'9'){if(ch=='-')f=-1;ch=getchar();}
        while(ch>='0'&&ch<='9'){x=x*10+ch-'0';ch=getchar();}
        return x*f;
    }
    int buf[10];
    inline void write(int i) {
      int p = 0;if(i == 0) p++;
      else while(i) {buf[p++] = i % 10;i /= 10;}
      for(int j = p-1; j >=0; j--) putchar('0' + buf[j]);
      printf("
    ");
    }
    */
    //**************************************************************************************
    struct node
    {
        int x,y;
    }; 
    bool cmp(node a,node b)
    {
        return a.x<b.x;
    }
    node a[maxn];
    map<int,int> H;
    vector<int> aa[maxn];
    int dp[maxn];
    int main()
    {
        int n;
        scanf("%d",&n);
        for(int i=0;i<n;i++)
        {
            scanf("%d",&a[i].x);
            H[a[i].x]++;
            aa[a[i].x].push_back(i+1);
        }
        int now=0;
        int tot=0;
        vector<int> ans;
        while(tot<n&&now>=0)
        {
            if(H[now]>0)
            {
                H[now]--;
                ans.push_back(aa[now][dp[now]]);
                dp[now]++;
                now++;  
            }   
            else
                now-=3;
        }   
        if(ans.size()!=n)
            puts("Impossible");
        else
        {
            puts("Possible");
            for(int i=0;i<ans.size();i++)
                printf("%d ",ans[i]);
        } 
    } 
  • 相关阅读:
    MyBatis笔记:xml映射文件
    MyBatis笔记:xml配置文件
    JSP获取当前系统时间并显示
    使用<jsp:forward>和<jsp:param>
    JSP简单总结
    网页版学生管理系统简易版DOM
    当为servlet配置时出现servlet标签报错
    给js的事件驱动函数添加快捷键
    js的表格对象和DOM联合操作
    Centos7安装Greenplum5.3单机版教程
  • 原文地址:https://www.cnblogs.com/qscqesze/p/4422609.html
Copyright © 2011-2022 走看看